/* -*- C++ -*-
 * src/test/graph_wrapper_test.cc - Part of LEMON, a generic C++ optimization library
 *
 * Copyright (C) 2004 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
 * (Egervary Combinatorial Optimization Research Group, EGRES).
 *
 * Permission to use, modify and distribute this software is granted
 * provided that this copyright notice appears in all copies. For
 * precise terms see the accompanying LICENSE file.
 *
 * This software is provided "AS IS" with no warranty of any kind,
 * express or implied, and with no claim as to its suitability for any
 * purpose.
 *
 */

#include<iostream>
#include<lemon/concept_check.h>

#include<lemon/smart_graph.h>
#include<lemon/concept/graph.h>

#include<lemon/list_graph.h>
#include<lemon/full_graph.h>
#include<lemon/graph_wrapper.h>

#include"test/test_tools.h"
#include"test/graph_test.h"

/**
\file
This test makes consistency checks of graph wrappers.

\todo More extensive tests are needed 
*/

using namespace lemon;
using namespace lemon::concept;



int main() 
{
  {
    checkConcept<StaticGraph, GraphWrapper<StaticGraph> >();

    checkConcept<StaticGraph, RevGraphWrapper<StaticGraph> >();

    checkConcept<StaticGraph, SubGraphWrapper<StaticGraph, 
      StaticGraph::NodeMap<bool> , StaticGraph::EdgeMap<bool> > >();
    checkConcept<StaticGraph, NodeSubGraphWrapper<StaticGraph, 
      StaticGraph::NodeMap<bool> > >();
    checkConcept<StaticGraph, EdgeSubGraphWrapper<StaticGraph, 
      StaticGraph::EdgeMap<bool> > >();
    
    checkConcept<StaticGraph, SubBidirGraphWrapper<StaticGraph, 
      StaticGraph::EdgeMap<bool>, StaticGraph::EdgeMap<bool> > >();

    checkConcept<StaticGraph, BidirGraph<StaticGraph> >();

    checkConcept<StaticGraph, ResGraphWrapper<StaticGraph, int, 
      StaticGraph::EdgeMap<int>, StaticGraph::EdgeMap<int> > >();

//     function_requires<StaticGraphConcept<ErasingFirstGraphWrapper<Graph, Graph::NodeMap<Graph::Edge> > > >();
  }
  std::cout << __FILE__ ": All tests passed.\n";

  return 0;
}
